/*
 * xplay --- X sound player.
 *
 * This program is copyright 1994 by Robert S. Thau.  It is offered as
 * is, and no warranty is offered of suitability or fitness for any
 * particular purpose; use at your own risk.  Contents may have settled
 * during shipment.  The program may be redistributed for noncommercial
 * purposes only, so long as all files contain a prominent notice of when
 * they were last changed, and who changed them.
 */

/*
 * xfile structure handles the audio file; managed by the routines in file.c
 * We allocate a linked list of in-memory buffers for the file as data
 * arrives.  read_whats_available() reads as much more as it can into the
 * buffer without blocking.
 *
 * Here and often elsewhere, char * returns are for error messages, to allow
 * the routine to synthesize something intelligible.  NULL indicates success.
 */
     
struct xfile_chunk
{
  long offset_in_file;
  char *data;
  char *data_end;
  char *good_data_end;
  struct xfile_chunk *next;
};
     
struct xfile
{
  int fd;
  
  int total_bytes_read;
  int eof;
  
  struct xfile_chunk *first;
  struct xfile_chunk *last;
};
     
void read_whats_available (struct xfile *x);
char *open_xfile (struct xfile *x, char *filename);
char *save_xfile (struct xfile *x, char *filename);

