#include <stdio.h>
#include <memory.h>
#include <malloc.h>

#include "audio.h"

/*
 * xplay --- X sound player.
 *
 * This program is copyright 1994 by Robert S. Thau.  It is offered as
 * is, and no warranty is offered of suitability or fitness for any
 * particular purpose; use at your own risk.  Contents may have settled
 * during shipment.  The program may be redistributed for noncommercial
 * purposes only, so long as all files contain a prominent notice of when
 * they were last changed, and who changed them.
 */

struct file_header
{
  long magic;
  long header_sz;
  long data_sz;
  long coding;
  long rate;
  long channels;
};

char *
grok_au (struct format *samp, char *hdr)
{
  struct file_header *header = (struct file_header *)hdr;
  int sample_elt_size = 1;

  samp->data_offset = header->header_sz;
  samp->channels = header->channels;
  samp->rate = header->rate;
  samp->little_endian = 0;

  switch (header->coding)
  {
  case 1: samp->coding = CODE_ULAW; samp->nbits = 8; break;
  case 2: samp->coding = CODE_LINEAR; samp->nbits = 8; break;
  case 3: samp->coding = CODE_LINEAR; samp->nbits = 16; break;
  case 4: samp->coding = CODE_LINEAR; samp->nbits = 24; break;
  case 5: samp->coding = CODE_LINEAR; samp->nbits = 32; break;
  default: return "Unrecognized sound type in Sun .snd file";
  }
    
  if (header->data_sz > 0)
  {
    samp->num_samples = header->data_sz;
    samp->num_samples /= (samp->nbits / 8);
    samp->num_samples /= samp->channels;

    samp->file_size = header->data_sz + header->header_sz;
  }
  else
  {
    samp->file_size = -1;
    samp->num_samples = -1;
  }

  return NULL;
}
