.TH XPlay 1 "Release 0.7" "MIT AI lab"
.SH NAME
xplay - .au/AIFF sound player
.SH SYNOPSIS
\fBxplay\fP [ \fI-toolkitoption\fP ... ] [ -timeout \fIint\fP ]
    [ -port [ speaker | headphone | ... ]] [ -stay ]
    [ -forkoff ] [ - | \fIfilename\fP ]
.SH DESCRIPTION
The \fIxplay\fP program plays sound contained in .au and AIFF
formatted sound files; it can also handle many WAVE files (effectively
the same WAVE variants as understood by the well-known utility
sox(1)).  Additionally, it can read audio data from standard input and
play it as it comes in; this can be useful with Web clients such as
Netscape which are capable of passing audio data to a player as it
arrives from over the network.  (See STREAMING, below for info on how
to best use this feature).
.PP
The source of the sound to be read is specified by the only non-option
argument, which is either a filename, or `-'.  The latter indicates that the
program should read from standard input.  The program determines the
sound format itself by inspection; if it can't find a file header for
the recognized formats, it attempts to process the input as unadorned
8-kHz mono ulaw samples (the format specified in RFC 1521 for the MIME
type \fBaudio/basic\fP).
.PP
\fIxplay\fP also presents a window allowing the user to control
playback by pausing it, or seeking back to a former position.
.SH OPTIONS
The \fIxplay\fP program accepts all of the standard X Toolkit command 
line options as well as the following:
.TP 8
.I -port
The value of this option directs the program to play sound through a
particular output port.  Valid options are `\fBheadphone\fP',
`\fBspeaker\fP', `\fBline_out\fP', or `\fBdefault\fP', the last of which
gets you whichever device of the previous three was most recently
used.
.IP 
This option defaults to the value of the \fBXPlay*port\fP resource,
which in turn defaults, if unset, to `\fBdefault\fP'.  If the port
specified does not exist on the hardware, that too is equivalent to
`\fBdefault\fP'.
.TP 8
.I -timeout
Upon playing the end of the sound file, \fIxplay\fP surrenders the
audio device, pauses for this many seconds waiting for the user to
intervene, and if the user doesn't, exits.  This defaults to the value
of the \fBXPlay*timeout\fP resource, which defaults in turn to 3.  The
timeout may also be disabled by means of the \fI-stay\fP option, or by
manually setting the \fIStay\fP togglebutton on the gui to "on".
.TP 8
.I -stay
This sets the \fIStay\fP toggle on the gui on, disabling the
end-of-play timeout.
.TP 8
.I -forkoff
If this option is supplied, \fIxplay\fP immediately forks, and the
parent process exits.  This action partially dissociates \fIxplay\fP from
its parent process; that can be useful for working around bugs in
certain other programs (see STREAMING).  This may also be requested by
setting the Boolean \fBXPlay*detach\fP resource to true.
.SH INTERFACE
The \fIxplay\fP window has the following controls:
.TP 8
.I Timeline slider
This slider displays a visual indication of how much of the entire
file has already been played; it advances as more data is played, and
may be repositioned to selectively play portions of the file.
(However, when reading from standard input, you obviously can't play
data that hasn't arrived yet).
.TP 8
.I Play/Pause
When this button is pressed, audio playback pauses (if it was
playing), or resumes (if it was paused); the label on the button
changes to reflect the new state.
.TP 8
.I Fast-forward (>>), Reverse (<<)
These change the position of the ``virtual playback head'', in the
manner of the like-labeled buttons on a walkman.  When reading audio
from standard input, you can't fast-forward past what has already been
read.  (The same effect may be achieved by directly moving the
time-line slider).
.TP 8
.I Volume slider
Allows you to adjust the volume of playback.  
.TP 8
.I Quit
When this button is pressed, \fIxplay\fP exits.
.TP 8
.I Save
This saves the sound we are playing to a file, which can be useful if it
came in from standard input.  If the input has not been completely
read, the user is queried (via dialog box) if you really want a
fragment; if so, a fragment is saved.
.TP 8
.I Stay
This is a toggle.  When it is on, the program will \fInot\fP
automatically exit after finishing playback.
.SH STREAMING
The \fIxplay\fP program can be used with certain Web browsers, in
particular Netscape, in order to play sound as it comes over the Net,
rather than waiting for the entire file to arrive.  In order to use
\fIxplay\fP in this fashion, add a line of roughly this form to your
\fB\&.mailcap\fP file:
.IP
.B audio/*; xplay -forkoff -; stream-buffer-size=8000
.LP
Note the use of the \fB-forkoff\fP option.  This is necessary with
early releases of Netscape (through at least 1.0), which expect
streaming players to die immediately when they receive the last byte
of audio, and freeze up if they don't.  The \fB-forkoff\fP option
causes \fIxplay\fP to fork and carry on all business in the child;
since the parent immediately dies, Netscape doesn't hang trying to
wait for it.
.PP
(The line above is a catch-all, which will not interfere with other
players for particular audio formats, such as audio MPEG, which are
not handled by \fIxplay\fP.  Incidentally, it does work to pipe the
output of \fImaplay_ulaw -s\fP through \fIxplay\fP, if you want the gui
features of xplay with audio MPEG; this also tends to stutter less
than raw \fImaplay\fP when playing off the net, due to \fIxplay\fP's
more aggressive buffering).
.SH
.SH ENVIRONMENT
.PP
.TP 8
.B DISPLAY
to get the default host and display number.
.TP 8
.B XENVIRONMENT
to get the name of a resource file that overrides the global resources
stored in the RESOURCE_MANAGER property.
.SH BUGS
The program allocates enough virtual memory to fit the entire sound
file.  This is necessary to support rewinding to the beginning of a
sound file read from a socket, but it does risk running out of swap
space.  Right now, the program stops dead if this happens; it could
be handled better by discarding the beginning of the file to free up
space.
.PP
When reading from the network on a slow day, playback may run ahead of
what's available.  In this case, it can help to pause playback for a
minute or two and let the network get ahead.  (This still saves time
over the non-streaming case, which would have you download the whole
thing before you could hear any of it --- particularly in cases where
hearing the first 30 seconds lets you know that you don't actually
want the rest of it).  
.PP
Compressed AIFF and WAVE files are not supported.  WAVE support is
limited, perhaps unreasonably so --- we only handle PCM WAVE files
with a single, simple data chunk.  
.SH AUTHOR
Robert Thau, MIT AI Lab
